service_3_crud/crud/urls.py
from django.conf.urls import url
from django.urls import path
from django.views.generic.base import RedirectView
from .views import *
#url for app
app_name = 'crud'

urlpatterns = [
    url(r'^$', RedirectView.as_view(url='view/', permanent = False), name='$'),
    url(r'view/', view, name='view'),
    url(r'create/', create, name='create'),
    path(r'edit/<id_item>', edit, name='edit'),
    path(r'delete/<id_item>', delete, name='delete'),
    path(r'detail/<id_item>', detail, name='detail'),
    url(r'auth_login/', auth_login, name='auth_login'),
]

service_3_crud/service_3_crud/urls.py
from django.contrib import admin
from django.urls import path, include
import crud.urls as crud

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include(crud, namespace='crud')),
]

service_3_crud/crud/models.py
from django.db import models

class Utang(models.Model):
    KATEGORI_LIST = (
        ('utang', 'utang'),
        ('piutang', 'piutang'),
    )
    nama = models.CharField(max_length=60)
    kategori = models.CharField(max_length=60, choices=KATEGORI_LIST)
    jumlah = models.IntegerField(default=0)
    keterangan = models.TextField()

service_3_crud/crud/views.py
from django.http import HttpResponseRedirect
from django.shortcuts import render
from .auth_utils import ambil_token, ambil_resource
from .models import Utang

def detail(request, id_item):
    response = {}
    if not request.session.get('access_token'):
        return render(request, 'login.html', response)
    resp = ambil_resource(request.session.get('access_token'))
    json_response = resp.json()
    if 'error' in json_response:
        response['expired'] = "expired"
        return render(request, 'login.html', response)
    utang = Utang.objects.get(id=id_item)
    response['id'] = utang.id
    response['nama'] = utang.nama
    response['kategori'] = utang.kategori
    response['jumlah'] = utang.jumlah
    response['keterangan'] = utang.keterangan
    return render(request, 'detail.html', response)

def view(request):
    response = {}
    if not request.session.get('access_token'):
        return render(request, 'login.html', response)
    resp = ambil_resource(request.session.get('access_token'))
    json_response = resp.json()
    if 'error' in json_response:
        response['expired'] = "expired"
        return render(request, 'login.html', response)
    models = Utang.objects.all().order_by('-id').values('id', 'nama', 'kategori', 'jumlah', 'keterangan')
    response['utangs'] = models
    return render(request, 'crud.html', response)

def create(request):
    response = {}
    if not request.session.get('access_token'):
        return render(request, 'login.html', response)
    resp = ambil_resource(request.session.get('access_token'))
    json_response = resp.json()
    if 'error' in json_response:
        response['expired'] = "expired"
        return render(request, 'login.html', response)
    if request.POST:
        nama = request.POST['nama']
        kategori = request.POST['kategori']
        jumlah = int(request.POST['jumlah'])
        keterangan = request.POST['keterangan']
        new_utang = Utang(nama=nama, kategori=kategori, jumlah=jumlah, keterangan=keterangan)
        new_utang.save()
    return HttpResponseRedirect('/view')

def edit(request, id_item):
    response = {}
    if not request.session.get('access_token'):
        return render(request, 'login.html', response)
    resp = ambil_resource(request.session.get('access_token'))
    json_response = resp.json()
    if 'error' in json_response:
        response['expired'] = "expired"
        return render(request, 'login.html', response)
    if request.POST:
        utang = Utang.objects.get(id=id_item)
        utang.nama = request.POST['nama']
        utang.kategori = request.POST['kategori']
        utang.jumlah = int(request.POST['jumlah'])
        utang.keterangan = request.POST['keterangan']
        utang.save()
    return HttpResponseRedirect('/view')

def delete(request, id_item):
    response = {}
    if not request.session.get('access_token'):
        return render(request, 'login.html', response)
    resp = ambil_resource(request.session.get('access_token'))
    json_response = resp.json()
    if 'error' in json_response:
        response['expired'] = "expired"
        return render(request, 'login.html', response)
    utang = Utang.objects.get(id=id_item)
    utang.delete()
    return HttpResponseRedirect('/view')

def auth_login(request):
    response = {}
    if request.POST:
        username = request.POST['username']
        password = request.POST['password']
        resp = ambil_token(username, password, 'oSheev1Woh0OhFieza5ud1ahm9xooNgiuxaefaok', 'Tiongoh1phi0hithai6meiz4aj5roo8Boh0eeb6a')
        json_response = resp.json()
        if 'error' in json_response:
            response['error'] = "error"
            return render(request, 'login.html', response)
        access_token = json_response['access_token']
        request.session['access_token'] = access_token
        models = Utang.objects.all().order_by('-id').values('id', 'nama', 'kategori', 'jumlah', 'keterangan')
        response['utangs'] = models
        return render(request, 'crud.html', response)

service_3_crud/templates/base.html
{% load static %}
<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta name="theme-color" content="#342345">
  <title> {% block title %} Service 3 of LAW_KEMAS {% endblock %}</title>
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
  <link href='https://fonts.googleapis.com/css?family=Raleway:900|Raleway' rel='stylesheet'>
  <meta name="viewport" content="initial-scale=1.0, width=device-width" />

  {% block css %}
      
  {% endblock %}
</head>

<body>
  <div class="se-pre-con"></div>
  <header>
  <!-- navbar -->
  {% block header %}
  {% endblock %}
</header>
<content>
  <!-- content -->

    {% block content %}
    {% endblock %}
 
</content>
<footer>
  {% block footer %}
  {% endblock %}
</footer>

  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js"></script>
  {% block javascript %}
  {% endblock %}
</body>

</html>

service_3_crud/templates/crud.html
{% extends "base.html" %}
{% load static %}
{% block css %}
<style type="text/css">
  .center {
    align-items: center;
    text-align: center;
    margin: auto;
  }
  .margin-top-20 {
    margin-top: 20px;
  }
  .margin-bottom-10 {
    margin-bottom: 10px;
  }
</style>
{% endblock %}

{% block content %}
<section name="container" class="content">
  <h2>CREATE UTANG RECORD</h2>
  <form id="form" name="form" method="POST" action="{% url 'crud:create' %}">
    {% csrf_token %}
    <input type="text" name="nama" placeholder="nama">
    <br>
    <label for="kategori">Pilih kategori:</label>
    <select id="kategori" name="kategori">
      <option value="utang">utang</option>
      <option value="piutang">piutang</option>
    </select>
    <br>
    <input type="integer" name="jumlah" placeholder="jumlah" min="0">
    <br>
    <textarea name="keterangan" rows="10" cols="30" placeholder="Keterangan">Keterangan</textarea>
    <br>
    <button type="submit">Submit</button>
  </form>

  <div class="files-section">
    <div class="center margin-top-20 margin-bottom-10">
      <h2>RECORD LIST</h2>
    </div>
    <table class="table">
      <thead>
        <tr>
          <th scope="col">#</th>
          <th scope="col">nama</th>
          <th scope="col">kategori</th>
          <th scope="col">jumlah</th>
          <th scope="col">delete</th>
        </tr>
      </thead>
      <tbody>
        {% for utang in utangs %}
        <tr>
          <th scope="row"><a href="/detail/{{ utang.id }}">{{ forloop.counter }}</a></th>
          <td>{{ utang.nama }}</td>
          <td>{{ utang.kategori }}</td>
          <td>{{ utang.jumlah }}</td>
          <td><a href="/delete/{{ utang.id }}">DELETE</a></td>
        </tr>
        {% endfor %}
      </tbody>
    </table>
  </div>
</section>
{% endblock %}

{% block javascript %}
{% endblock %}

service_3_crud/templates/detail.html
{% extends "base.html" %}
{% load static %}
{% block css %}
<style type="text/css">
  .center {
    align-items: center;
    text-align: center;
    margin: auto;
  }
  .margin-top-20 {
    margin-top: 20px;
  }
  .margin-bottom-10 {
    margin-bottom: 10px;
  }
</style>
{% endblock %}

{% block content %}
<section name="container" class="content">
  <h2>DETAIL UTANG</h2>
  <form id="form" name="form" method="POST" action="{% url 'crud:edit' id_item=id %}">
    {% csrf_token %}
    <input type="text" name="nama" placeholder="nama" value="{{ nama }}">
    <br>
    <label for="kategori">Pilih kategori:</label>
    <select id="kategori" name="kategori" value="{{ kategori }}">
      <option value="utang"
        {% if kategori == 'utang' %}selected="selected"{% endif %}
        >utang
      </option>
      <option value="piutang"
        {% if kategori == 'piutang' %}selected="selected"{% endif %}
        >piutang
      </option>
    </select>
    <br>
    <input type="integer" name="jumlah" placeholder="jumlah" min="0" value="{{ jumlah }}">
    <br>
    <textarea name="keterangan" rows="10" cols="30" placeholder="Keterangan">{{ keterangan }}</textarea>
    <br>
    <button type="submit">Submit</button>
  </form>
</section>
{% endblock %}

{% block javascript %}
{% endblock %}

service_3_crud/templates/login.html
{% extends "base.html" %}
{% load static %}
{% block css %}
{% endblock %}

{% block content %}
<section name="container" class="content">
  <h2>LOG IN</h2>
  <form id="form" name="form" method="POST" action="{% url 'crud:auth_login' %}" enctype="multipart/form-data">
    {% csrf_token %}
    <input type="text" name="username" placeholder="username">
    <input type="password" name="password" placeholder="password">
    <button type="submit">Submit</button>
  </form>

  {% if error %}
    <h3>Wrong username or password</h3>
  {% elif expired %}
    <h3>Session has expired, please login again</h3>
  {% endif %}

</section>
{% endblock %}

{% block javascript %}
{% endblock %}